## arb 6.0.2

=== Makefile ===
# =============================================================== #
#                                                                 #
#   File      : Makefile                                          #
#                                                                 #
#   Institute of Microbiology (Technical University Munich)       #
#   http://www.arb-home.de/                                       #
#                                                                 #
# =============================================================== #

# -----------------------------------------------------
# The ARB Makefile is aware of the following defines:
#
# CC                    C compiler (should be defined by OS)
# CXX                   C++ compiler (should be defined by OS)
#
# BUILDHOST_64=0/1      1=>compile on 64 bit platform (defaults to ARB_64)
# DEVELOPER=name        special compilation (values: ANY,RELEASE,your name)
# OPENGL=0/1            whether OPENGL is available
#
# -----------------------------------------------------
# ARB Makefile and ARB source code are aware of the following defines:
#
# $(MACH)               name of the machine (LINUX or DARWIN; see config.makefile)
# DEBUG                 compiles the DEBUG sections
# DEBUG_GRAPHICS        all X-graphics are flushed immediately (for debugging)
# ARB_64=0/1            1=>compile 64 bit version
# UNIT_TESTS=0/1        1=>compile in unit tests and call them after build
# COVERAGE=0/1/2        compile in gcov support (useful together with UNIT_TESTS=1)
#                       0=no, 1+2=compile in, 1=show
# STABS=0/1             force stabs format? (0 = "use default format")
#
# -----------------------------------------------------
# The ARB source code is aware of the following defines:
#
# NDEBUG                doesn't compile the DEBUG sections
# DEVEL_$(DEVELOPER)    developer-dependent flag (enables you to have private sections in code)
#                       DEVELOPER='ANY' (default setting) will be ignored
#                       configurable in config.makefile
#
# -----------------------------------------------------
# Read configuration 
include config.makefile

# set defaults for variables commented out in config.makefile:
ifndef DARWIN
	DARWIN:=0
endif
ifndef LINUX
	LINUX:=0
endif
ifndef DEBIAN
	DEBIAN:=0
endif
ifndef REDHAT
	REDHAT:=0
endif
ifndef ARB_64
	ARB_64=1#default to 64bit
endif

# compiler settings:
ifneq ($(CC),use__A_CC__instead_of__CC)

A_CC:=$(CC)# compile C
A_CXX:=$(CXX)# compile C++

# uncomment to ensure no submakefile uses CC and CXX directly
override CC:=use__A_CC__instead_of__CC
override CXX:=use__A_CXX__instead_of__CXX

endif

export CC CXX A_CC A_CXX

ifeq ($(LD_LIBRARY_PATH),'')
LD_LIBRARY_PATH:=${ARBHOME}/lib
endif

ifeq ($(DARWIN),1)
LD_LIBRARY_PATH:=${ARBHOME}/lib
endif

FORCEMASK = umask 002
NODIR=--no-print-directory

SED:=$(ARBHOME)/SH/arb_sed
READLINK:=$(ARBHOME)/SH/arb_readlink

# ---------------------- compiler version detection

# supported gcc versions:
ALLOWED_gcc_VERSIONS=\
	4.3.1 4.3.2 4.3.3 4.3.4 \
	4.4.1       4.4.3       4.4.5 4.4.6  4.4.7 \
	      4.5.2 \
	4.6.1 4.6.2 4.6.3 \
	4.7.1 4.7.2 4.7.3 \
	4.8.0 4.8.1 4.8.2 4.8.3 \
	4.9.0 4.9.1 \

# supported clang versions:
ALLOWED_clang_VERSIONS=\
	4.2.1 \

# ----------------------

COMPILER_INFO:=$(shell SOURCE_TOOLS/arb_compiler_version.pl $(A_CXX))
COMPILER_NAME:=$(word 1,$(COMPILER_INFO))
COMPILER_VERSION:=$(word 2,$(COMPILER_INFO))

USE_CLANG:=0
ifneq ($(COMPILER_NAME),gcc)
 ifeq ($(COMPILER_NAME),clang)
  USE_CLANG:=1
 else
  $(error failed to detect COMPILER_NAME (got '$(COMPILER_NAME)', expected 'clang' or 'gcc'))
 endif
endif

ifeq ($(USE_CLANG),1)
ALLOWED_COMPILER_VERSIONS=$(ALLOWED_clang_VERSIONS)
else
ALLOWED_COMPILER_VERSIONS=$(ALLOWED_gcc_VERSIONS)
endif

COMPILER_VERSION_ALLOWED=$(strip $(subst ___,,$(foreach version,$(ALLOWED_COMPILER_VERSIONS),$(findstring ___$(version)___,___$(COMPILER_VERSION)___))))

#---------------------- split gcc version 

SPLITTED_VERSION:=$(subst ., ,$(COMPILER_VERSION))

USE_GCC_MAJOR:=$(word 1,$(SPLITTED_VERSION))
USE_GCC_MINOR:=$(word 2,$(SPLITTED_VERSION))
USE_GCC_PATCHLEVEL:=$(word 3,$(SPLITTED_VERSION))

USE_GCC_452_OR_HIGHER:=
USE_GCC_47_OR_HIGHER:=
USE_GCC_48_OR_HIGHER:=

ifeq ($(USE_GCC_MAJOR),4)
 ifeq ($(USE_GCC_MINOR),5)
  ifneq ('$(findstring $(USE_GCC_PATCHLEVEL),23456789)','')
   USE_GCC_452_OR_HIGHER:=yes
  endif
 else
  ifneq ('$(findstring $(USE_GCC_MINOR),6789)','')
   USE_GCC_452_OR_HIGHER:=yes
   ifneq ($(USE_GCC_MINOR),6)
    USE_GCC_47_OR_HIGHER:=yes
    ifneq ($(USE_GCC_MINOR),7)
     USE_GCC_48_OR_HIGHER:=yes
    endif
   endif
  endif
 endif
else
 USE_GCC_452_OR_HIGHER:=yes
 USE_GCC_47_OR_HIGHER:=yes
 USE_GCC_48_OR_HIGHER:=yes
endif

#---------------------- define special directories for non standard builds

ifeq ($(DARWIN),1)
	OSX_FW:=/System/Library/Frameworks
	OSX_FW_OPENGL:=$(OSX_FW)/OpenGL.framework/Versions/A/Libraries
	OSX_FW_GLUT:=$(OSX_FW)/GLUT.framework/Versions/A/Libraries
	OSX_FW_IMAGEIO:=$(OSX_FW)/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/Resources
endif

#----------------------

ifeq ($(DARWIN),1)
	LINK_STATIC=1# link static
else
	LINK_STATIC=0# link dynamically
#	LINK_STATIC=1# link static (testing only)
endif

shared_cflags :=# flags for shared lib compilation
lflags :=# linker flags
clflags :=# linker flags (when passed through gcc)
extended_warnings :=# warning flags for C and C++-compiler
extended_cpp_warnings :=# warning flags for C++-compiler only


ifeq ($(DEBUG),0)
	dflags := -DNDEBUG# defines
	ifeq ($(USE_CLANG),1)
		cflags := -O3# compiler flags (C and C++)
	else
		cflags := -O4# compiler flags (C and C++)
		lflags += -O2# linker flags
		clflags += -Wl,-O2# passthrough linker flags
	endif
endif

ifeq ($(DEBIAN),1)
	lflags += -rpath=/usr/lib/arb/lib -z relro
	clflags += -Wl,-rpath=/usr/lib/arb/lib -Wl,-z,relro
endif

ifeq ($(DEBUG),1)
	dflags := -DDEBUG

	gdb_common := -g -g3 -ggdb -ggdb3

ifeq ($(STABS),1)
	cflags := -O0  $(gdb_common) -gstabs+  # using stabs+ (enable this for bigger debug session: debugs inlines, quick var inspect, BUT valgrind stops working :/)
else
	cflags := -O0 $(gdb_common) # (using dwarf - cant debug inlines here, incredible slow on showing variable content)
endif

#	cflags := -O0 $(gdb_common) -gdwarf-3 # (specify explicit dwarf format)
#	cflags := -O0  $(gdb_common) -gstabs  # using stabs (same here IIRC)
#	cflags := -O2 $(gdb_common) # use this for callgrind (force inlining)

ifeq ($(DARWIN),0)
	lflags += -g
	clflags += -Wl,-g
endif

# control how much you get spammed
# (please do not change default in SVN, use developer specific setting as below)
	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --original# dont modify compiler output
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --hide-Noncopyable-advices
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --show-useless-Weff++
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --no-warnings
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --only-first-error
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --no-warnings --only-first-error
ifeq ($(DEVELOPER),ELMAR)
	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --only-first-error
endif


# Enable extra warnings
	extended_warnings :=
	extended_cpp_warnings :=

#       C and C++ 
	extended_warnings     += -Wwrite-strings -Wunused -Wno-aggregate-return -Wshadow

#       C++ only 
	extended_cpp_warnings += -Wnon-virtual-dtor -Wreorder -Wpointer-arith -Wdisabled-optimization -Wmissing-format-attribute
	extended_cpp_warnings += -Wctor-dtor-privacy# < gcc 3
# 	extended_cpp_warnings += -Wfloat-equal# gcc 3.0

# ------- above only warnings available in 3.0

 ifneq ('$(COMPILER_VERSION)','4.7.3') # g++ crashes on GenomeImport.cxx when -Weffc++ is active (bug reported)
	extended_cpp_warnings += -Weffc++# gcc 3.0.1
 endif
	extended_cpp_warnings += -Wmissing-noreturn# gcc 3.0.2
#	extended_cpp_warnings += -Wold-style-cast# gcc 3.0.4 (warn about 28405 old-style casts)
	extended_cpp_warnings += -Winit-self# gcc 3.4.0
	extended_cpp_warnings += -Wstrict-aliasing# gcc 3.4
	extended_cpp_warnings += -Wextra# gcc 3.4.0
 ifeq ('$(USE_GCC_452_OR_HIGHER)','yes')
	extended_cpp_warnings += -Wlogical-op# gcc 4.5.2
 endif

 ifeq ($(DEBUG_GRAPHICS),1)
	dflags += -DDEBUG_GRAPHICS
 endif
endif

#---------------------- turn off clang bogus warnings

ifeq ($(USE_CLANG),1)
# -Wmismatched-tags warns about struct/class mismatch in forward declarations (which is explicitely allowed)
# -Wchar-subscripts reports too many bogus warnings for "array['x']" (when 'x' is known to be in range [0..128])
# -Wunused-private-field report too many false positives (currently ~ 2 of 3)
# -Wstring-plus-int warns about common ARB coding practice
# -Wgnu-static-float-init warns about accepted GNU extension
	extended_cpp_warnings += -Wno-mismatched-tags -Wno-char-subscripts -Wno-unused-private-field -Wno-string-plus-int -Wno-gnu-static-float-init
endif

#---------------------- developer

ifneq ($(DEVELOPER),ANY) # ANY=default setting (skip all developer specific code)
	dflags += -DDEVEL_$(DEVELOPER)# activate developer/release specific code
endif

ifndef SHOWTODO
 ifeq ($(DEVELOPER),RALF)
	SHOWTODO:=1
 else
	SHOWTODO:=0
 endif
endif
ifeq ($(SHOWTODO),1)
	dflags += -DWARN_TODO# activate "TODO" warnings
endif

#---------------------- 32 or 64 bit

ifndef BUILDHOST_64
	BUILDHOST_64:=$(ARB_64)# assume build host is same as version (see config.makefile)
endif

cross_cflags:=
cross_lflags:=
cross_clflags:=

ifeq ($(ARB_64),1)
	dflags += -DARB_64 #-fPIC 
	shared_cflags += -fPIC

	ifeq ($(BUILDHOST_64),1)
#		build 64-bit ARB version on 64-bit host
		CROSS_LIB:=# empty = autodetect below
		ifeq ($(DARWIN),1)
			cross_cflags  += -arch x86_64
			cross_lflags  += -arch x86_64
			cross_clflags += -arch x86_64
		endif
	else
#		build 64-bit ARB version on 32-bit host
		CROSS_LIB:=/lib64
		cross_cflags += -m64
		cross_lflags += -m64 -m elf_x86_64
		cross_clflags += -m64 -Wl,-m64,-m,elf_x86_64
	endif
else
	ifeq ($(BUILDHOST_64),1)
#		build 32-bit ARB version on 64-bit host
		CROSS_LIB:=# empty = autodetect below
		cross_cflags += -m32
		cross_lflags += -m32 -m elf_i386 
		cross_clflags += -m32 -Wl,-m32,-m,elf_i386 
	else
#		build 32-bit ARB version on 32-bit host
		CROSS_LIB:=/lib
	endif
endif

cflags  += $(cross_cflags)
lflags  += $(cross_lflags)
clflags += $(cross_clflags)

ifeq ('$(CROSS_LIB)','')
# autodetect libdir
	ifeq ($(ARB_64),1)
		CROSS_LIB:=$(shell (test -d /lib64 && echo lib64) || echo lib)
	else
		CROSS_LIB:=$(shell (test -d /lib32 && echo lib32) || echo lib)
	endif
endif

#---------------------- unit tests

ifndef UNIT_TESTS
	UNIT_TESTS=0#default is "no tests"
endif
ifeq ($(UNIT_TESTS),1)
	dflags += -DUNIT_TESTS
	UNIT_TESTER_LIB=UNIT_TESTER/UNIT_TESTER.a
else
	UNIT_TESTER_LIB=
endif

#---------------------- use gcov

ifndef COVERAGE
	COVERAGE=0#default is "no"
endif
ifneq ($(COVERAGE),0)
	GCOVFLAGS=-ftest-coverage -fprofile-arcs
	cflags += $(GCOVFLAGS)
	EXECLIBS=-lgcov
else
	GCOVFLAGS=
	EXECLIBS=
endif

#---------------------- other flags

dflags += -D$(MACH) # define machine

ifeq ($(DARWIN),1)
	shared_cflags += -fno-common
else
	dflags +=  $(shell getconf LFS_CFLAGS)
endif

cflags += -pipe
cflags += -fmessage-length=0# don't wrap compiler output
cflags += -fshow-column# show columns
cflags += -funit-at-a-time
cflags += -fPIC
cflags += -fno-common# link all global data into one namespace
cflags += -fstrict-aliasing# gcc 3.4
ifeq ('$(USE_GCC_48_OR_HIGHER)','yes')
 cflags += -fno-diagnostics-show-caret#gcc 4.8 (4.7.?)
endif
#cflags += -save-temps# uncomment to see preprocessor output

#---------------------- X11 location

ifeq ($(DARWIN),1)
	XHOME:=$(PREFIX)
else
 ifeq ($(DEBIAN),1)
	XHOME:=$(PREFIX)
 else
	XHOME:=/usr/X11R6
 endif
endif

=== debian/changelog ===
arb (6.0.2-1+deb8u1) jessie; urgency=medium

  * Skip compiler version check at all
    Closes: #793187

 -- Andreas Tille <tille@debian.org>  Thu, 10 Dec 2015 10:55:21 +0100

arb (6.0.2-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
    Closes: #741890
  * debian/upstream -> debian/upstream/metadata
  * debian/control:
     - Build-Depends: added libglib2.0-dev
     - Depends: added mafft, mrbayes
  * debian/rules
     - Add explicite --remove-section=.comment option to manual strip call
  * cme fix dpkg-control
  * arb-common.dirs: Do not create unneeded lintian dir
  * Add turkish debconf translation (thanks for the patch to Mert Dirik
    <mertdirik@gmail.com>)
    Closes: #757497

  [ Elmar Pruesse ]
  * patches removed:
     - 10_config.makefiles.patch,
       80_no_GL.patch
         removed in favor of creating file from config.makefile.template via 
         sed in debian/control
     - 20_Makefile_main.patch
         merged upstream
     - 21_Makefiles.patch
         no longer needed
     - 30_tmpfile_CVE-2008-5378.patch: 
         merged upstream
     - 50_fix_gcc-4.8.patch:
         merged upstream
     - 40_add_libGLU.patch:
         libGLU not needed for arb_ntree)
     - 60_use_debian_packaged_raxml.patch:
         merged upstream
     - 70_hardening.patch
         merged upstream
     - 72_add_math_lib_to_linker.patch
         does not appear to be needed
  * patches added:
     - 10_upstream_r12793__show_db_load_progress:
         backported patch showing progress while ARB is loading a database
         (needed as indicator/splash screen while ARB is launching)
     - 20_upstream_r12794__socket_permissions:
         backported security fix
     - 30_upstream_r12814__desktop_keywords:
         backported add keywords to desktop (fixes lintian warning)
     - 40_upstream_r12815__lintian_spelling:
         backported fix for lintian reported spelling errors
     - 50_private_nameservers
         change configuration to put nameservers into users home dirs
         (avoids need for shared writeable directory)
     - 60_use_debian_phyml
         use phyml from debian package for both interfaces in ARB
  * debian/rules:
     - create config.makefile from override_dh_configure target
     - use "make tarfile" in override_dh_install
     - remove extra cleaning not needed for ARB 6
     - use "dh_install --list-missing" to avoid missing files
     - added override_dh_fixperms target
  * debian/control:
     - added libarb-dev package
     - Depends: added phyml, xdg-utils
     - Suggests: removed phyml
     - fix lintian duplicate-short-description (new descriptions)
  * debian/*.install:
     - "unrolled" confusing globbing to select files
     - pick files from debian/tmp
     - moved all config files to /etc/arb
  * debian/arb-common.templates: updated
  * scripts:
     - removed arb-add-pt-server
     - launch-wrapper: 
       - only add demo.arb to newly created $ARBUSERDATA
       - pass commandline arguments through bin/arb wrapper
     - preinst: removing old PT server index files on upgrade from 5.5*
     - postinst: set setgid on shared PT dir
  * rewrote arb.1 manfile
  * added file icon for ARB databases
  * using upstream arb_tcp.dat

 -- Elmar Pruesse <elmar@pruesse.net>  Tue, 02 Sep 2014 15:15:06 +0200

=== debian/control ===
Source: arb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Elmar Pruesse <elmar@pruesse.net>
Section: non-free/science
XS-Autobuild: yes
Priority: optional
Build-Depends: chrpath,
               debhelper (>= 9),
               freeglut3-dev | libglu-dev,
               libbio-perl-perl,
               libglew-dev,
               libglib2.0-dev,
               libglw1-mesa-dev,
               libglu1-mesa-dev,
               libmotif-dev,
               libpng-dev,
               libtiff-dev,
               libxaw7-dev,
               libxml2-utils,
               libxpm-dev,
               lynx,
               time,
               perl-doc,
               xsltproc,
               xutils-dev
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/arb/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/arb/trunk/
Homepage: http://www.arb-home.de/

Package: arb
Architecture: amd64 i386 kfreebsd-i386 kfreebsd-amd64
Depends: arb-common (= ${source:Version}),
         fastdnaml,
         libarb (= ${binary:Version}),
         openssh-client,
         mafft,
         mrbayes,
         phylip,
         phyml,
         raxml,
         readseq,
         transfig,
         tree-puzzle,
         xdg-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: bioperl,
            xfig
Suggests: arb-database,
          gnuplot,
          gv
Description: Graphical suite for phylogenetic sequence analysis 
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 The ARB project (latin, "arbor"=tree) is a joint initiative of the Lehrstuhl
 fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/ and the
 Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.

Package: libarb
Architecture: amd64 i386 kfreebsd-i386 kfreebsd-amd64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: arb
Description: Graphical suite for phylogenetic sequence analysis (libraries)
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 The ARB project (latin, "arbor"=tree) is a joint initiative of the Lehrstuhl
 fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/ and the
 Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.
 .
 This package contains the dynamic libraries which are used by arb.

Package: libarb-dev
Architecture: amd64 i386 kfreebsd-i386 kfreebsd-amd64
Section: non-free/libdevel
Depends: libarb (= ${binary:Version}),
         ${misc:Depends}
Description: Graphical suite for phylogenetic sequence analysis (development files)
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 The ARB project (latin, "arbor"=tree) is a joint initiative of the Lehrstuhl
 fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/ and the
 Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.
 .
 This package contains headers and static libs needed to link against libARBDB.

Package: arb-common
Architecture: all
Depends: adduser,
         arb-doc (= ${source:Version}),
         ghostscript | postscript-preview,
         gv | postscript-viewer,
         perl-modules,
         ${misc:Depends},
         ${perl:Depends}
Recommends: arb
Description: Graphical suite for phylogenetic sequence analysis (common files)
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 This package contains the architecture independent scripts of Arb.

Package: arb-doc
Architecture: all
Section: non-free/doc
Depends: ghostscript | postscript-preview,
         gv | postscript-viewer,
         ${misc:Depends}
Suggests: arb
Description: Graphical suite for phylogenetic sequence analysis (documentation)
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 This package contains the documentation for the package arb.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for arb using quilt

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
pkgcom=$(pkg)-common
pkgdoc=$(pkg)-doc
common=debian/$(pkgcom)

ARBHOME=$(CURDIR)

BITARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS)
ifeq ($(BITARCH),64)
    ARB_64:=1
else
    ARB_64:=0
endif

LD_LIBRARY_PATH := $(ARBHOME)/lib:$(LD_LIBRARY_PATH)
PATH := $(ARBHOME)/bin:$(PATH)
LC_ALL := C

export ARBHOME LD_LIBRARY_PATH PATH LC_ALL

%:
	dh $@ --parallel

config.makefile: config.makefile.template
	# ARB's build system is configured with config.makefile. This file is
	# created on the first run of make from config.makefile.template. We
	# just use sed here to set the desired parameters:
	sed -e 's/DEVELOPER := ANY/DEVELOPER := RELEASE/;'\
            -e 's/ARB_64 := 1/ARB_64 := $(ARB_64)/;'\
            -e 's/# DEBIAN := 1/DEBIAN := 1/;' \
             config.makefile.template > config.makefile

override_dh_auto_build:
	$(MAKE) all

override_dh_auto_configure: config.makefile

override_dh_auto_clean: config.makefile
	# config.makefile is required to run make clean, hence the dependency
	# on ..._auto_configure.
	$(MAKE) clean
	rm config.makefile
	# ARB does not have "distclean" or "realclean". Remove some leftovers:
	rm -f UNIT_TESTER/Makefile.setup.local
	find -name \*.log -a ! -name phyml-manual.log -print0 | xargs -0 rm -f
	rm -f TEMPLATES/arb_build.h

override_dh_install:
	# ARB has no "install" target. It has "tarfile_quick", though, which
	# creates a tarball for distribution. We build this and unpack it
	# into debian/tmp so that dh_install can pick up the files.
	make tarfile_quick
	rm -rf debian/tmp
	mkdir debian/tmp
	tar -C debian/tmp -xzf arb.tgz
	rm -rf debian/tmp-dev
	mkdir debian/tmp-dev
	tar -C debian/tmp-dev -xzf arb-dev.tgz
	rm arb.tgz arb-dev.tgz

	# remove some files we don't need in the package:
	rm -rf debian/tmp/lib/addlibs # external libs are packages
	rm  -f debian/tmp/lib/arb_tcp_org.dat # managed in etc
	rm  -f debian/tmp/lib/GPL.txt # included in copyright
	rm  -f debian/tmp/lib/Makefile # spurious in upstream
	rm  -f debian/tmp/arb_install.sh # no installer needed

	dh_install --list-missing

	# the check is needed to make sure it will not fail when doing binary-arch only builds
	if [ -e debian/$(pkgcom)/usr/lib/arb/SH/arb_create_debian_conffile ] ; then \
	    # Move SH/README :to docs \
	    cp -a SH/README debian/$(pkgcom)/usr/share/doc/arb/README_SH ; \
	    # Fix permission of scripts \
	    chmod a+x debian/$(pkgcom)/usr/lib/arb/SH/arb_create_debian_conffile ; \
	    chmod a+x debian/$(pkgcom)/usr/lib/arb/lib/macro.head ; \
	fi

override_dh_strip:
	# Fix rpath issue (once libarb is installed)
	if [ -e debian/libarb/usr/lib/arb/lib/ARB.so ] ; then \
	    chrpath --delete debian/libarb/usr/lib/arb/lib/ARB.so ; \
	fi
	dh_strip 
	find debian/libarb-dev -name \*.a -print0 | xargs -0 -n 1 strip --remove-section=.comment

override_dh_shlibdeps:
	dh_shlibdeps -a -l debian/libarb/usr/lib

override_dh_builddeb:
	dh_builddeb -- -Z xz

override_dh_fixperms:
	dh_fixperms
	-chmod 0644 debian/arb-common/etc/arb/submit/*
	-chmod 0644 debian/libarb-dev/usr/include/arb/xml.hxx
	-chmod 0755 debian/arb-common/usr/lib/arb/lib/macro.head

# To update po files as recommended in po-debconf(7) 
debian/po/templates.pot: debian/arb-common.templates
	@debconf-updatepo

=== debian/watch ===
version=3

opts="downloadurlmangle=s{([\d.]+)/$}{$1/arb-$1-source.tgz},filenamemangle=s/\/$/.tgz/" \
   http://download.arb-home.de/release/ arb-(\d+.*)/
